# -*- encoding: utf-8 -*
from django.core import serializers
from django.shortcuts import render_to_response, redirect, get_object_or_404
from django.template import Context, RequestContext
from django.utils import simplejson
from auf.django.emploi import models as emploi
from restkit import request, Resource
import datamaster_modeles.models as ref
import poster
import urllib2
from auf.django.emploi import settings


STATUS_OK = 200

def req(*args, **kwargs):
    timeout = 10
    if not kwargs.has_key('timeout'):
        kwargs['timeout'] = timeout
    return request(*args, **kwargs)


def read_response(request):
    """
    La prod en Python2.5 avec restkit 3.3.2 en mode SSL
    semble capricieuse.
    """
    data = request._body.raw.readall()
    if data == '':
        data = request._body.raw.read()
    return data


class API:
    def __init__(self, request, env):
        self.request = request
        self.env = env

    def offre_emploi_liste(self,):
        url = settings.RECRUTEMENT_URLS[self.env] + "offre_emploi_liste/"
        r = req(url)
        data = read_response(r)
        offres = [offre.object for offre in serializers.deserialize("json", data)]
        return offres

    def offre_emploi(self, offre_id):
        url = settings.RECRUTEMENT_URLS[self.env] + "offre_emploi/?id=%s"
        r = req(url % offre_id)
        data = read_response(r)
        offres = [o.object for o in serializers.deserialize("json", data)]
        if len(offres) == 0:
            return offres[0]
        else:
            return offres

    def candidat_add(self, offre_id,):
        url = settings.RECRUTEMENT_URLS[self.env] + "candidat_add/%s/" % offre_id
        r = Resource(url)
        params = self.request.POST
        for k, up_file in self.request.FILES.items():
            params[k] = up_file
        opener = poster.streaminghttp.register_openers()
        datagen, headers = poster.encode.multipart_encode(params)
        request = urllib2.Request(url, datagen, headers)
        resp = urllib2.urlopen(request)
        if resp.code == STATUS_OK:
            candidats = [c.object for c in serializers.deserialize("json", resp.read())]
            if len(candidats) == 1: 
                return candidats[0]
        return None
